module DownloadableController
  extend ActiveSupport::Concern

  # GET /learning_objects/1/download
  def download
    downloadable.download(current_user, request.remote_ip)
    link = downloadable.download_link
    if !link.blank?
      redirect_to link
    else
      render status: :internal_server_error
    end
  end

  protected

  def downloadable
    raise NotImplementedError
  end

end
